import sys
import time

def fib_loop(n):
    if n < 2:
        return 1

    F_n_minus_1 = 1
    F_n_minus_2 = 1

    for k in range(1, n):
        F_n = F_n_minus_1 + F_n_minus_2

        F_n_minus_2 = F_n_minus_1
        F_n_minus_1 = F_n

    return F_n


def fib_rec(n):
    if n < 2:
        return 1
    else:
        return fib_rec(n-1) + fib_rec(n-2)


fibs = {0: 1, 1: 1}
def fib_dict(n):
    if n in fibs:
        return fibs[n]
    x = fib_dict(n-1) + fib_dict(n-2)
    fibs[n] = x
    return x


assert len(sys.argv) == 2, 'Benutzung: ' + sys.argv[0] + ' n'

n = int(sys.argv[1])
tic = time.time()
x = fib_loop(n)
print('Schleife:', x, time.time() - tic)
tic = time.time()
x = fib_rec(n)
print('Rekursion:', x, time.time() - tic)
tic = time.time()
x = fib_dict(n)
print('Dictionary:', x, time.time() - tic)
